/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSDockTile;

import dstep.appkit.NSView;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSDockTile : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSSize size ()
	{
		return invokeObjcSelf!(NSSize, "size");
	}

	void setContentView (NSView view)
	{
		return invokeObjcSelf!(void, "setContentView:", NSView)(view);
	}

	NSView contentView ()
	{
		return invokeObjcSelf!(NSView, "contentView");
	}

	void display ()
	{
		return invokeObjcSelf!(void, "display");
	}

	void setShowsApplicationBadge (bool flag)
	{
		return invokeObjcSelf!(void, "setShowsApplicationBadge:", bool)(flag);
	}

	bool showsApplicationBadge ()
	{
		return invokeObjcSelf!(bool, "showsApplicationBadge");
	}

	void setBadgeLabel (NSString string)
	{
		return invokeObjcSelf!(void, "setBadgeLabel:", NSString)(string);
	}

	NSString badgeLabel ()
	{
		return invokeObjcSelf!(NSString, "badgeLabel");
	}

	Object owner ()
	{
		return invokeObjcSelf!(Object, "owner");
	}
}

