/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSPropertyMapping;

import dstep.foundation.NSDictionary;
import dstep.foundation.NSExpression;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPropertyMapping : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSString name ()
	{
		return invokeObjcSelf!(NSString, "name");
	}

	void setName (NSString name)
	{
		return invokeObjcSelf!(void, "setName:", NSString)(name);
	}

	NSExpression valueExpression ()
	{
		return invokeObjcSelf!(NSExpression, "valueExpression");
	}

	void setValueExpression (NSExpression expression)
	{
		return invokeObjcSelf!(void, "setValueExpression:", NSExpression)(expression);
	}

	NSDictionary userInfo ()
	{
		return invokeObjcSelf!(NSDictionary, "userInfo");
	}

	void setUserInfo (NSDictionary userInfo)
	{
		return invokeObjcSelf!(void, "setUserInfo:", NSDictionary)(userInfo);
	}
}

