/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corevideo.CVBuffer;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVBase;
import dstep.corevideo.CVReturn;

struct __CVBuffer;

alias uint CVAttachmentMode;
alias __CVBuffer* CVBufferRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVBufferPropagatedAttachmentsKey;
		const CFStringRef kCVBufferNonPropagatedAttachmentsKey;
		const CFStringRef kCVBufferMovieTimeKey;
		const CFStringRef kCVBufferTimeValueKey;
		const CFStringRef kCVBufferTimeScaleKey;
	}
}

enum
{
	kCVAttachmentMode_ShouldNotPropagate = 0,
	kCVAttachmentMode_ShouldPropagate = 1
}

extern (C)
{
	CVBufferRef CVBufferRetain (CVBufferRef buffer);
	void CVBufferRelease (CVBufferRef buffer);
	void CVBufferSetAttachment (CVBufferRef buffer, CFStringRef key, CFTypeRef value, uint attachmentMode);
	CFTypeRef CVBufferGetAttachment (CVBufferRef buffer, CFStringRef key, CVAttachmentMode* attachmentMode);
	void CVBufferRemoveAttachment (CVBufferRef buffer, CFStringRef key);
	void CVBufferRemoveAllAttachments (CVBufferRef buffer);
	CFDictionaryRef CVBufferGetAttachments (CVBufferRef buffer, uint attachmentMode);
	void CVBufferSetAttachments (CVBufferRef buffer, CFDictionaryRef theAttachments, uint attachmentMode);
	void CVBufferPropagateAttachments (CVBufferRef sourceBuffer, CVBufferRef destinationBuffer);
}