/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSMethodSignature;

import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSMethodSignature : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSMethodSignature signatureWithObjCTypes (char* types)
	{
		return invokeObjcSuperClass!(NSMethodSignature, "signatureWithObjCTypes:", char*)(types);
	}

	NSUInteger numberOfArguments ()
	{
		return invokeObjcSelf!(NSUInteger, "numberOfArguments");
	}

	char* getArgumentTypeAtIndex (NSUInteger idx)
	{
		return invokeObjcSelf!(char*, "getArgumentTypeAtIndex:", NSUInteger)(idx);
	}

	NSUInteger frameLength ()
	{
		return invokeObjcSelf!(NSUInteger, "frameLength");
	}

	bool isOneway ()
	{
		return invokeObjcSelf!(bool, "isOneway");
	}

	char* methodReturnType ()
	{
		return invokeObjcSelf!(char*, "methodReturnType");
	}

	NSUInteger methodReturnLength ()
	{
		return invokeObjcSelf!(NSUInteger, "methodReturnLength");
	}
}

