/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSURLCredentialStorage;

import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.foundation.NSURLCredential;
import dstep.foundation.NSURLProtectionSpace;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;



import bindings = dstep.foundation.NSURLCredentialStorage_bindings;

private NSString NSURLCredentialStorageChangedNotification_;

NSString NSURLCredentialStorageChangedNotification ()
{
	if (NSURLCredentialStorageChangedNotification_)
		return NSURLCredentialStorageChangedNotification_;
	
	return NSURLCredentialStorageChangedNotification_ = new NSString(bindings.NSURLCredentialStorageChangedNotification);
}

class NSURLCredentialStorage : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSURLCredentialStorage sharedCredentialStorage ()
	{
		return invokeObjcSuperClass!(NSURLCredentialStorage, "sharedCredentialStorage");
	}

	NSDictionary credentialsForProtectionSpace (NSURLProtectionSpace space)
	{
		return invokeObjcSelf!(NSDictionary, "credentialsForProtectionSpace:", NSURLProtectionSpace)(space);
	}

	NSDictionary allCredentials ()
	{
		return invokeObjcSelf!(NSDictionary, "allCredentials");
	}

	void setCredential (NSURLCredential credential, NSURLProtectionSpace space)
	{
		return invokeObjcSelf!(void, "setCredential:forProtectionSpace:", NSURLCredential, NSURLProtectionSpace)(credential, space);
	}

	void removeCredential (NSURLCredential credential, NSURLProtectionSpace space)
	{
		return invokeObjcSelf!(void, "removeCredential:forProtectionSpace:", NSURLCredential, NSURLProtectionSpace)(credential, space);
	}

	NSURLCredential defaultCredentialForProtectionSpace (NSURLProtectionSpace space)
	{
		return invokeObjcSelf!(NSURLCredential, "defaultCredentialForProtectionSpace:", NSURLProtectionSpace)(space);
	}

	void setDefaultCredential (NSURLCredential credential, NSURLProtectionSpace space)
	{
		return invokeObjcSelf!(void, "setDefaultCredential:forProtectionSpace:", NSURLCredential, NSURLProtectionSpace)(credential, space);
	}
}

