/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTCaptureVideoPreviewOutput;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.qtkit.QTCaptureConnection;
import dstep.qtkit.QTCaptureOutput;
import dstep.qtkit.QTKitDefines;
import dstep.qtkit.QTSampleBuffer;

const TQTCaptureVideoPreviewOutputDelegate = `

	void captureOutput (QTCaptureOutput captureOutput, CVImageBufferRef videoFrame, QTSampleBuffer sampleBuffer, QTCaptureConnection connection)
	{
		return invokeObjcSelf!(void, "captureOutput:didOutputVideoFrame:withSampleBuffer:fromConnection:", QTCaptureOutput, CVImageBufferRef, QTSampleBuffer, QTCaptureConnection)(captureOutput, videoFrame, sampleBuffer, connection);
	}

	//mixin ObjcBindMethod!(captureOutput, "captureOutput:didOutputVideoFrame:withSampleBuffer:fromConnection:");

`;

class QTCaptureVideoPreviewOutput : QTCaptureOutput
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSDictionary pixelBufferAttributes ()
	{
		return invokeObjcSelf!(NSDictionary, "pixelBufferAttributes");
	}

	void setPixelBufferAttributes (NSDictionary pixelBufferAttributes)
	{
		return invokeObjcSelf!(void, "setPixelBufferAttributes:", NSDictionary)(pixelBufferAttributes);
	}

	Object delegate_ ()
	{
		return invokeObjcSelf!(Object, "delegate");
	}

	void setDelegate (Object delegate_)
	{
		return invokeObjcSelf!(void, "setDelegate:", Object)(delegate_);
	}
}

