/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CIPlugIn;

import dstep.foundation.Foundation;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class CIPlugIn : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static void loadAllPlugIns ()
	{
		return invokeObjcSelfClass!(void, "loadAllPlugIns");
	}

	static void loadNonExecutablePlugIns ()
	{
		return invokeObjcSelfClass!(void, "loadNonExecutablePlugIns");
	}

	static void loadPlugIn (NSURL url, bool allowNonExecutable)
	{
		return invokeObjcSelfClass!(void, "loadPlugIn:allowNonExecutable:", NSURL, bool)(url, allowNonExecutable);
	}
}

